
# include "../slist.hh"
# include <stdio.h>
template<class T>
void
addInSet(slist<T*> *set, T *so)
// --------------------------------------------------
// add `so' in `set' if not already present
// so is a software object
{
  slist<T*>::iterator p;
  bool found;

  for (p=set->begin(), found=false; (p != set->end()) && (! found); p++)
	found = (so == *p);

  if (! found)
	set->push_back(so);
}

void *operator new(size_t sz)
// --------------------------------------------------
{
  //  printf("---IN NEW(%d)\n", sz);
  return( malloc(sz) );
}
  
    
void operator delete(void *o)
// --------------------------------------------------
{
  //  printf("---IN DELETE(%x)\n", o);
  free(o);
}


class CharSeq {
// --------------------------------------------------
protected:
  char *_str;

public:
  CharSeq(char *s = NULL) { _str = s; };

  char *string() const { return(_str); };
};

main()
// --------------------------------------------------
{
  slist<CharSeq*> l;
  slist<CharSeq*>::iterator p;
  CharSeq *keep;
  int i;

  l.push_front(new CharSeq("-2-"));
  l.push_front(new CharSeq("-1-"));

  l.push_back(new CharSeq("-3-"));
  l.push_back(new CharSeq("-4-"));
  l.push_back(keep = new CharSeq("-5-"));

  printf("size=%d\n", l.size());
  for (p=l.begin(); p != l.end(); p++)
	printf("elt: %s\n", (*p)->string() );

  addInSet( &l, keep);
  addInSet( &l, keep);
  addInSet( &l, keep);
  addInSet( &l, keep);

  printf("size=%d\n", l.size());
  for (p=l.begin(); p != l.end(); p++)
	printf("elt:%s\n", (*p)->string() );
}
