#include "mammal.hh"
# include <stdio.h>
# include <stdlib.h>
# include <iostream.h>
#include "../../filemem/utilFileMem.h"

void main();


void *operator new(size_t sz)
// -------------------------------------------------- //
{
  char *space;
  space =  allocFileMem(sz);
  printf("---IN NEW(%d) -> %x\n", sz, space);
  return( space );
}


void operator delete(void *o)
// -------------------------------------------------- //
{
  printf("---IN DELETE(%x)\n", o);
  freeFileMem(o);
}


struct animals
{
  cow *c;
  mammal *m;
};


    extern _etext;
     extern _edata;
     extern _end;

#define DESTROY 0


void animalworks()
// -------------------------------------------------- //
{
  struct animals *a;
  int result;
  int useMode;
  int fileMode;
  int junk = 2;
  cow *z = new cow("abc");
  mammal *y = new mammal("def");
  int *obj;

  printf("Address of main = %x etext=%x edata=%x end=%x nbt=%x bvn=%x\n", main,
_etext,
_edata,
_end,  mammal::nb_teeth,  mammal::hello);
  obj = (int *)z;
  printf("... cow %x structure %x %x %x %x \n", z, *obj, *(obj +1), *(obj +2), *(obj+3));
  obj = (int *)y;
  printf("... mam %x structure %x %x %x %x \n", y, *obj, *(obj +1), *(obj +2), *(obj+3));


  cout << "Enter 1 for creation, 0 to use existing\n";
  cin >> useMode;
  cout << "mode entered is: " << useMode << " junk is " << junk << "\n";

  fileMode = useMode ? UFM_NEW : UFM_WRITE;
  result = initGrowableFileMem("test.mf", fileMode, 1, 100);
  if(result != 0)
  {
    printf("Failed to init file mem rc=%d\n", result);
    exit(0);
  }

  if(useMode)
  {
    a = new animals;

    a->c = new cow("daisy");    a->c->age = 20;
    obj = (int *)(a->c);
    printf(".. dcow %x structure %x %x %x %x \n", (a->c), *obj, *(obj +1), *(obj+2),*(obj+3));

    a->m = new mammal("ziggy");    a->m->age = 12;
    obj = (int *)(a->m);
    printf(".. dmam %x structure %x %x %x %x \n", (a->m), *obj, *(obj +1), *(obj+2),*(obj+3));


  }
  else
  {
    a= (struct animals *)getFirstBlockOfFileMem();
  }
  printf("First block = %x; a=%x\n", getFirstBlockOfFileMem(),a);
  debugPrintFileMem();

  a->m->hello();
  a->c->hello();


#if DESTROY
  delete(a->c);
  delete(a->m);

  delete animals;

  debugPrintFileMem();
#endif
  terminateFileMem();
}


